/*
 * $Id: Queue.h 26 2011-06-09 10:24:02Z benoit $
 * $Author: benoit $
 * $Date: 2011-06-09 12:24:02 +0200 (jeu., 09 juin 2011) $
 * $Rev: 26 $
 * 
 * 
 * 
 * 
 * 
 */
 
#ifndef __QUEUE_H__
#define    __QUEUE_H__


#include <stdint.h>
#include "mbedNet.h"

struct Queue
{
    uint8_t            pushIndex, 
                    popIndex;
    void            *entries[QUEUE_MAX_ENTRY_COUNT + 1];
    int16_t            size;
};
typedef struct Queue Queue_t;


Queue_t    *Queue_Alloc(int16_t size);
int32_t     Queue_Push(Queue_t *queue, void *entry);
int32_t     Queue_Pop(Queue_t *queue, void **entry);
int32_t     Queue_Peek(Queue_t *queue, void **entry);
int32_t     Queue_Free(Queue_t *queue);
Bool_t      Queue_IsEmpty(const Queue_t *queue);
Bool_t      Queue_IsFull(const Queue_t *queue);


#endif /* __QUEUE_H__ */

